<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<% try { // START: DEBUG %>
<%@ page errorPage="/errorPage.jsp" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/citation.tld" prefix="citation" %>

<html:xhtml />

<%@ page import="javax.servlet.http.HttpServletRequest" %>
<%@ page import="javax.servlet.jsp.PageContext" %>

<%@ page import="com.sas.actionprovider.HttpActionProvider" %>

<%@ page import="com.sas.apps.citation.controller.action.reportbuilder.BuilderBrowseImageRespositoryDialogAction" %>
<%@ page import="com.sas.apps.citation.util.Log" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.beans.reportbuilder.BuilderImagePropertiesForm" %>
<%@ page import="com.sas.apps.citation.view.help.HelpUtils" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.CitationButton" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.filechooser.image.ImageChooser" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.filechooser.tableview.FileInformationTable" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.filechooser.tableview.renderer.AllFilesPredicate" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.filechooser.tableview.renderer.NonFolderMutableActivationOverridePredicate" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.filechooser.tableview.renderer.OnlyFoldersPredicate" %>
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>
<%@ page import="com.sas.apps.citation.view.util.ThemeUtils" %>
<%@ page import="com.sas.apps.citation.view.util.ViewUtils" %>
<%@ page import="com.sas.apps.citation.util.CommonUtils" %>
<%@ page import="com.sas.apps.citation.model.user.SessionScopeManager" %>
<%@ page import="com.sas.apps.citation.util.CommonUtils" %>


<jsp:useBean id="builderImagePropertiesDialogForm" class="com.sas.apps.citation.view.beans.reportbuilder.BuilderImagePropertiesForm" scope="session" />

<%=ThemeUtils.getCitationThemableStyleSheetImportHtml(request, "citation_editImage.css") %>
<script type="text/javascript" src="<%=ViewUtils.getWebAppRelScriptsPath()%>citation_editImage.js"></script>
<script type="text/javascript" src="<%=ViewUtils.getWebAppRelScriptsPath()%>citation_remoteFileSelector.js"></script>

<script type="text/javascript">
/*<![CDATA[*/
function closeSelf()
{
   var winOpener = self.opener;
   if (winOpener != null)
   {
      if (winOpener.cwDialogManager != null)
      {
         winOpener.cwDialogManager.closeDialogWindow( self ); <%-- op succeeded so close the dialog and dispatch WINDOW_CLOSING & WINDOW_CLOSED events --%>
      }
   }
   else
   {
      cwDialogManager.closeDialogWindow( self );
   }
}
/*]]>*/ 
</script>
<%  Object rc = request.getAttribute(BuilderBrowseImageRespositoryDialogAction.RESULT_CODE_KEY);
    Object cmdKey = request.getAttribute(BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY);
    if( BuilderBrowseImageRespositoryDialogAction.RC_SUCCESS.equals(rc)
        && BuilderBrowseImageRespositoryDialogAction.CMD_OK_DIALOG_KEY.equals(cmdKey))
    { %>
<script type="text/javascript">
/*<![CDATA[*/
closeSelf();
/*]]>*/ 
</script>
<%     return; //exit out of service() method. Nothing left to do so everything else is a waste of time.
    }//if( BuilderBrowseImageRespositoryDialogAction.RC_SUCCESS.equals(rc) )

  CitationButton okButton = CitationButton.createStandaloneButton(request, "okButton",
      PagePropertyBean.getLabelWithMnemonic(pageContext,"ok.button.txt"),
      "onInsertOkClick();");
  okButton.setEpilog("\n<script type=\"text/javascript\">\n\tsetupComponentMonitors();\n</script>");
  request.setAttribute(CitationButton.OK_DIALOG_BUTTON, okButton);
  
  CitationButton cancelButton = CitationButton.createStandaloneButton(request, "cancelButton",
      PagePropertyBean.getLabelWithMnemonic(pageContext,"cancel.button.txt"),
      "cwDialogManager.cancelSelf();");
  request.setAttribute(CitationButton.CANCEL_DIALOG_BUTTON, cancelButton);
  
  Log logger = ViewUtils.getPageLogger(request, this);
  SessionScopeManager smgr = SessionScopeManager.getSessionScopeManager(request);
  ImageChooser imageChooser = builderImagePropertiesDialogForm.getImageChooser(smgr);
  prepareToRender( imageChooser, builderImagePropertiesDialogForm, pageContext, logger );

  builderImagePropertiesDialogForm.preRenderActivities(imageChooser, builderImagePropertiesDialogForm, pageContext, logger);
  FileInformationTable detailTable = imageChooser.getFileDetailsTable();
  String detailTableId = detailTable.getId(); //id of table body that displays metadata of sp's in current folder
  
  String thumbnailImageUrl = builderImagePropertiesDialogForm.getBrowserUrlForSelectedImageThumbnail();
  if (thumbnailImageUrl == null) thumbnailImageUrl = "";
  
  boolean isUpload = false;
  String selectionType = builderImagePropertiesDialogForm.getImageSelectionType();
  if (selectionType.equals(BuilderImagePropertiesForm.IMAGE_SELECTION_TYPE_UPLOAD))
      isUpload = true;  

  String selectedLocationPath = builderImagePropertiesDialogForm.getSelectedLocationForDisplay(request, response);
  if (CommonUtils.isEmptyOrWhiteSpace(selectedLocationPath)) selectedLocationPath = PagePropertyBean.getMessage(pageContext,"edit.report.image.properties.folder.placeholder.txt");    
  String openText = PagePropertyBean.getLabel(pageContext, "open.button.txt");
  String okText = PagePropertyBean.getLabel(pageContext, "ok.button.txt");
  
  int helpLinkId = (isUpload ? HelpUtils.HELP_SELECT_FOLDER : HelpUtils.HELP_SELECT_IMAGE);
  String helpLink = "if( cwOpenHelpDocDialog != null ) { cwOpenHelpDocDialog(event,'"
      + HelpUtils.getHelpTopicPath(request, helpLinkId)
      + "'); }";
  HelpUtils.createHelpButton(request, helpLink);
  /* ***
  CitationButton helpButton = CitationButton.createStandaloneButton(request, "helpButton",
      PagePropertyBean.getLabelWithMnemonic(pageContext,"help.button.txt"),
      helpLink);
  helpButton.setAccessKey(PagePropertyBean.getMnemonic(pageContext,"help.button.txt"));
  request.setAttribute(CitationButton.HELP_DIALOG_BUTTON, helpButton);
  */ 
%>
<script type="text/javascript">
/*<![CDATA[*/

function scrollSelectedTableItemIntoView()
{
   var listSelectionModel = WRSListSelectionModel.getInstance("<%=detailTableId%>");
   if (!listSelectionModel.isSelectionEmpty())
   {
      wrs_scrollTableItemIntoView(listSelectionModel.getFirstSelectedItem());
   }
}
<%-- //once page is fully loaded scroll selected data item into view --%>
dojo.addOnLoad(scrollSelectedTableItemIntoView);
dojo.addOnLoad(updateControlStates);
dojo.addOnLoad(processImageThumbnailOnPageLoad);

function onInsertOkClick()
{
   //alert( "ENTERING onInsertOkClick");
   var selectedFileElement = null;
   var LSM = WRSListSelectionModel.getInstance("<%=detailTableId%>");


   if (!LSM.isSelectionEmpty())
   {
      selectedFileElement = LSM.getFirstSelectedItem();
      if (selectedFileElement.wrsIsFolder)
      {
         if (selectedFileElement.wrsFileActivate != null)                                                   
         {                       
            selectedFileElement.wrsFileActivate();                                                         
         }
         return; //terminate folder processing
      }                                                                    
   }

   wrsCommitImageElement(selectedFileElement); //selectedFileElement may be null
   //alert( "EXITING onInsertOkClick");
}
    
function wrsCommitImageElement(selectionElement)
{
   if (selectionElement == null)
   {
      var LSM = WRSListSelectionModel.getInstance("<%=detailTableId%>");
   
      if (!LSM.isSelectionEmpty())
      {
         selectionElement = LSM.getFirstSelectedItem();
      }

   }
   var elementURL = selectionElement == null ? "" : selectionElement.wrsFileUrl; 
   wrsCommitSelectImage(elementURL);
}
    
function wrsCommitSelectImage(elementURL)
{
   var imageUrlElem = findDOM("imageUrl");
   //var selectedUploadDestinationElem = findDOM('selectedUploadDestination');
   
   if (<%=isUpload %>)
   {
      //selectedUploadDestinationElem.value = elementURL;
   }     
   else 
   {
      imageUrlElem.value = elementURL;
   }

   document.body.style.cursor = "wait"; <%-- until confirmation that overwrite succeeded --%>
   window.status = '<%=PagePropertyBean.escapeQuotesOnly(PagePropertyBean.getMessage(pageContext,"progress.wait.txt"))%>';
   var objForm = document.forms["builderImagePropertiesDialogForm"];

   var dialogCommandFormField = document.getElementById('<%=BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY%>');
   dialogCommandFormField.value = '<%=BuilderBrowseImageRespositoryDialogAction.CMD_OK_DIALOG_KEY%>';

   window.status = '<%=PagePropertyBean.escapeQuotesOnly(PagePropertyBean.getMessage(pageContext,"progress.wait.txt"))%>';
   progressIndicatorStart();
   objForm.submit();
}



function handleCitationWebConfirmation(actionConfirmed)
{
   if (actionConfirmed)
   {
      var objForm = document.forms["builderImagePropertiesDialogForm"];
      objForm.elements["builderImagePropertiesDialogForm.selectionConfirmed"].value = "TRUE";
      progressIndicatorStart();
      window.status = '<%=PagePropertyBean.escapeQuotesOnly(PagePropertyBean.getMessage(pageContext,"progress.wait.txt"))%>';
      objForm.submit();
   }
}
<%--
// -----------------------------------------------------------------------------
// Class used to enable/disable the ok button based on the selection of image
// -----------------------------------------------------------------------------
--%>
function EnableOkButtonListener(lsm, button)
{
   this.lsm = lsm;
   this.button = button;
}

EnableOkButtonListener.prototype.handleEvent = function(event)
{
   var bEnable = false;
   var lsModel = this.lsm;
   var bEnable = !lsModel.isSelectionEmpty();
   var okButtonText = findDOM('okButton_textObj');
   
   var isUploadSelected = <%=isUpload %>;

   if (! lsModel.isSelectionEmpty())
      {
         var selectedFileElement = lsModel.getFirstSelectedItem();
         if (selectedFileElement.wrsIsFolder)
         {
            okButtonText.innerHTML = "&nbsp;<%=openText %>&nbsp;";
         }
         else 
         {
            okButtonText.innerHTML = "&nbsp;<%=okText %>&nbsp;";
         }
      }

   if (isUploadSelected)
      {
      bEnable = true;
      }

   var buttonState = (bEnable ? setButtonState.ENABLED : setButtonState.DISABLED);
   setButtonState(event,this.button.id, buttonState );
}

EnableOkButtonListener.prototype.initialize = function ()
{
   registerEventHandler( this.lsm, WRSListSelectionModel.EVT_TYPE_SELECTION_CHANGE, this, false );
   this.handleEvent(); //set initial state of button
}

<%--
// -----------------------------------------------------------------------------
--%>


function ThumbnailListener(lsm)
{
   this.lsm = lsm;
}

ThumbnailListener.prototype.handleEvent = function(event)
{
   var lsModel = this.lsm;

   if (!lsModel.isSelectionEmpty())
   {
      var selectedItem = lsModel.getFirstSelectedItem();
      
      if (!selectedItem.wrsIsFolder)
      {
         var selectedItemUrl = selectedItem.wrsFileUrl;
         processThumbnail(selectedItemUrl);
      }
      else
      {

            var thumbnailImageObj = document.getElementById("thumbnailImageElement");
            var noImageTxtElem = document.getElementById("thumbnailImageElement_noImage");
            thumbnailImageObj.style.display="none";
            noImageTxtElem.style.display="block";
   }      
}
}

function processThumbnail(selectedItemUrl)
{
   var applyCmdElem = document.getElementById("<%=BuilderBrowseImageRespositoryDialogAction.APPLY_COMMAND %>");
   applyCmdElem.value = "<%=BuilderBrowseImageRespositoryDialogAction.APPLY_COMMAND_TYPE_THUMBNAIL %>";

   var dialogCommandFormField = document.getElementById('<%=BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY%>');
   dialogCommandFormField.value = '<%=BuilderBrowseImageRespositoryDialogAction.CMD_APPLY_DIALOG_KEY%>';

   var selectedImageForThumbnailUrlElem = findDOM("selectedImageForThumbnailUrl");
   selectedImageForThumbnailUrlElem.value = selectedItemUrl;
   
   var objForm = document.forms["builderImagePropertiesDialogForm"];

   dojo.io.bind({
        url: "builderBrowseImageRespositoryApplyCommand.do?session=required",
        handle: function(type, data, evt){onProcessThumbnailReturn(type, data, evt);},
        mimetype: "text/html",
        formNode: objForm,
        encoding: "UTF-8"
   }); 
}


function onProcessThumbnailReturn(type, data, evt)
{
   if (handleSessionTimeout(data, evt)) return;
   var emptyImage = '<%=ThemeUtils.getImageSourceURL(request,"wrs_1x1")%>';
   
   if (type == "load" && !dojo.lang.isEmpty(data))
   {
      var imageBrowserUrl = data;
      var thumbnailImageObj = document.getElementById("thumbnailImageElement");
      var noImageTxtElem = document.getElementById("thumbnailImageElement_noImage");
      var browserUrlForSelectedImageThumbnailObj = document.getElementById("browserUrlForSelectedImageThumbnail");
      if (!dojo.lang.isEmpty(imageBrowserUrl))
         thumbnailImageObj.src = imageBrowserUrl;
      else
         thumbnailImageObj.src = emptyImage;
      thumbnailImageObj.style.display="block";
      noImageTxtElem.style.display="none";
      browserUrlForSelectedImageThumbnailObj.value=imageBrowserUrl;
   }

}



ThumbnailListener.prototype.initialize = function ()
{
   registerEventHandler( this.lsm, WRSListSelectionModel.EVT_TYPE_SELECTION_CHANGE, this, false );
}

function setupComponentMonitors()
{
   var buttonObj = findDOM("okButton");
   var lsm = WRSListSelectionModel.getInstance("<%=detailTableId%>");
   var okButtonListener = new EnableOkButtonListener(lsm, buttonObj);
   okButtonListener.initialize();
   var isUploadSelected = <%=isUpload %>;
   if (!isUploadSelected)
   {
      var thumbnailSelection = new ThumbnailListener(lsm);
      thumbnailSelection.initialize();
   }
}

<%-- Method to be called by confirmation dialog logic in citationTemplate. 
Implementation forthis page handles confirmation foroverwriting image files. --%>
function handleCitationWebConfirmation (goAhead)
{
   if (goAhead)
   {
      var objForm = document.forms['builderImagePropertiesDialogForm'];
      objForm.elements["overwriteImageFileConfirmed"].value = "TRUE";
      objForm.submit();
   }
}

function updateControlStates()
{
   var uploadDestinationLabelObj = findDOM('uploadDestinationLabel');
   var chooseFolderLabelObj = findDOM('chooseFolderLabel');
   var thumbnailDivObj = findDOM('imageThumbnail');
   if (<%=isUpload %>)
   {
      uploadDestinationLabelObj.style.display="block";
      chooseFolderLabelObj.style.display="none";
      thumbnailDivObj.style.display="none";
   }
   else
   {
      uploadDestinationLabelObj.style.display="none";
      chooseFolderLabelObj.style.display="block";
      thumbnailDivObj.style.display="block";
   }
}

function processImageThumbnailOnPageLoad()
{
   var LSM = WRSListSelectionModel.getInstance("<%=detailTableId%>");
   
      var thumbnailImageObj = document.getElementById("thumbnailImageElement");
      var noImageTxtElem = document.getElementById("thumbnailImageElement_noImage");
      thumbnailImageObj.style.display="none";
      noImageTxtElem.style.display="block";

   if (!LSM.isSelectionEmpty())
   {
      var selectedItem = LSM.getFirstSelectedItem();
      if (!selectedItem.wrsIsFolder)
      {
          var selectedItemUrl = selectedItem.wrsFileUrl;
          if (<%=!isUpload %> && !dojo.lang.isEmpty(selectedItemUrl))
          {
             processThumbnail(selectedItemUrl);
   }
}
   }

}

/*]]>*/ 
</script>

<citation:form action="/builderBrowseImageRespository.do" method="post" enctype="multipart/form-data">

  <input type="hidden" id="<%=BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY %>" name="<%=BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY %>" value=""/>
  <input type="hidden" id="<%=BuilderBrowseImageRespositoryDialogAction.APPLY_COMMAND %>" name="<%=BuilderBrowseImageRespositoryDialogAction.APPLY_COMMAND %>" value=""/>
  <html:hidden property="imageUrl" styleId="imageUrl" value="<%= builderImagePropertiesDialogForm.getImageUrl() %>"/>
  <html:hidden property="builderImagePropertiesDialogForm.selectionConfirmed" value="FALSE" />
  <html:hidden property="overwriteImageFileConfirmed" styleId= "overwriteImageFileConfirmed" value="<%= new Boolean(false).toString() %>"/>
  <html:hidden property="selectedImageForThumbnailUrl" styleId= "selectedImageForThumbnailUrl" value=""/>


  <table border="0" cellpadding="0" cellspacing="0" summary="" width="100%">
    <tr>
      <td colspan="5" class="linePadding">&nbsp;</td>
    </tr>
    <tr>
      <td class="dialogSpacer">&nbsp;</td>
      <td colspan="2" class="layoutCell_uploadImageCtrlLabels" style="text-align:left;">
        <span class="header" style="display:block;" id="uploadDestinationLabel">
        <bean:message key="edit.report.image.properties.label.select.upload.image.destination.txt"/>
        </span>
        <span class="header" style="display:none;" id="chooseFolderLabel">
        <bean:message key="choose.report.location.txt"/>
        </span>
      </td>
      <td class="dialogSpacer">&nbsp;</td>
    </tr>

    <tr>
      <td class="dialogSpacer">&nbsp;</td>
      <td colspan="2" style="width:100%;text-align:left;">

        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="">
          <tr>
            <td>

              <%--
                Note: overriding of selection model's style setters must occur before rendering of table
                since they are called by script generated by renderer
              --%>
              <script type="text/javascript">
              /*<![CDATA[*/
              var listSelectionModel = WRSListSelectionModel.getInstance("<%=detailTableId%>");
              listSelectionModel.setSelectedStyle = function( item )
              {
                 item.className = "spSelectionElementSelectedStyle";
              };
              listSelectionModel.setUnSelectedStyle = function( item )
              {
                 item.className = "spSelectionElementUnSelectedStyle";
              };
              /*]]>*/ 
              </script>
              <!-- +++++++++ start of output from imageChooser.write()+++++++++ -->
                <%
                  logger.log(Log.DEBUG, "_start write image chooser");
                  imageChooser.setRequest(request);
                  imageChooser.setResponse(response);
                  imageChooser.write(out);
                  logger.log(Log.DEBUG, "_end write image chooser");
                %>
            
              <!-- +++++++++ end of output from imageChooser.write() +++++++++ -->

              <script type="text/javascript">
              /*<![CDATA[*/
              var selectedItems = listSelectionModel.getSelectedItems();
              for (var spIndex = listSelectionModel.getSelectedItemCount()-1; spIndex>=0; spIndex--)
              {
                 listSelectionModel.setSelectedStyle(selectedItems[spIndex]);
              }

              /*]]>*/ 
              </script>



    <%
        builderImagePropertiesDialogForm.postRenderActivities(imageChooser, builderImagePropertiesDialogForm, pageContext, logger);
    %>
            </td>
            <td class="dialogSpacer">&nbsp;</td>
          </tr>
         </table> 
      </td>
      <td class="dialogSpacer">&nbsp;</td>
    </tr>
    
    <tr>
      <td colspan="5" class="linePadding">&nbsp;</td>
    </tr>
    
    <tr>
      <td class="dialogSpacer">&nbsp;</td>
      <td colspan="2" style="white-space:nowrap;text-align:left;width:100%;">
      <%
                    String imageDisplayStyle = "block";
                    if (isUpload)
                    {
                        imageDisplayStyle = "none";
                    }    
      %>              

              <div id="imageThumbnail" style="display:<%=imageDisplayStyle%>;">
                <html:hidden property="browserUrlForSelectedImageThumbnail" styleId="browserUrlForSelectedImageThumbnail"/>
                  <table border="0" cellpadding="0" cellspacing="0" summary="">
                     <tr>
                          <%-- Selected image name (if any) --%>
                          <td style="text-align:left; vertical-align: top;">
                            <span id="selectedImageNameElement" class="header">
                            <bean:message key="edit.report.image.properties.label.selected.image.name.txt"/>
                            </span>
                          </td>

                          <td class="dialogSpacer">&nbsp;</td>
                          <%-- Thumbnail row --%>
                          <td>
                            <div id="selectedImageThumbnailContainer" style="display:block;white-space:normal;">
                              <div id="thumbnailContainer_imageSelected">
                                <span id="thumbnailImageElement_noImage" class="label" style="white-space:normal;display:block;">
                              <%=CommonUtils.htmlEncodeForDisplay(PagePropertyBean.getLabel(pageContext, "edit.report.image.properties.thumbnail.placeholder.txt"))%>
                             
                                </span>

                                <img src="<%=ThemeUtils.getImageSourceURL(request,"wrs_1x1")%>" id="thumbnailImageElement" alt=""  style="display:none;"/>
                              </div>

                            </div>
                          </td>
                          <td class="dialogSpacer">&nbsp;</td>
                     </tr><%-- End thumbnail row --%>
                  </table>
              </div>

<%
              String folderNameDisplayStyle = "none";
              if (isUpload)
              {
                  folderNameDisplayStyle = "block";
              }    
%>              
              <div id="selectedFolder" style="display:<%=folderNameDisplayStyle%>;">
                <table border="0" cellpadding="0" cellspacing="0" summary="">
                  <tr>
                    <td>
                      <table border="0" cellpadding="0" cellspacing="0" summary="">
                        <tr>
                          <%-- Selected folder name (if any) --%>
                          <td>
                            <span class="label">
                               <label for="foldername">
                                  <bean:message key="edit.report.image.properties.label.selected.foldername.txt"/>
                               </label>
                            </span>
                          </td>
                          <td class="dialogSpacer">&nbsp;</td>
              <td>
                  <span id="foldername" class="label">
                      <%=selectedLocationPath%>
                  </span>
              </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
              </div>

      </td>
      <td class="dialogSpacer">&nbsp;</td>
    </tr>
    
    
  </table>
  

</citation:form>

<% } catch (Exception ex) {
    PageErrorProcessor.setJspError(ex, pageContext, out);
} // END: DEBUG %>


<%!
    
    //prepare things that can be dynamic to each rendering.
    void prepareToRender(ImageChooser imageChooser, BuilderImagePropertiesForm imageSelectionForm, PageContext pgContext, Log logger)
    {
        HttpServletRequest request = (HttpServletRequest) pgContext.getRequest();
        String wrsDialogTitle = CommonUtils.htmlEncodeForDisplay(request.getParameter("wrsDialogTitle"));
        
        HttpActionProvider ap = imageChooser.getActionProvider();
        ap.setImageLocation(ThemeUtils.getImageDir(request));
        if (!CommonUtils.isEmptyOrWhiteSpace(wrsDialogTitle)) { 
            // pass dialog title down when drilling into folders
            ap.addExternalRequestParameter(null, "wrsDialogTitle", wrsDialogTitle);
        }
        ap.addExternalRequestParameter(null,
            BuilderBrowseImageRespositoryDialogAction.DIALOG_CMD_KEY,
            BuilderBrowseImageRespositoryDialogAction.CMD_APPLY_DIALOG_KEY );
        ap.setControllerURL("builderBrowseImageRespositoryApplyCommand.do"); /*I18nOK:LINE*/
        
        FileInformationTable fileInfoTable = imageChooser.getFileDetailsTable();
        if (BuilderImagePropertiesForm.IMAGE_SELECTION_TYPE_REPOSITORY
                .equals(imageSelectionForm.getImageSelectionType())) 
        {
            NonFolderMutableActivationOverridePredicate saveFileActivationOverride = new NonFolderMutableActivationOverridePredicate();
            saveFileActivationOverride.setJavascriptFunctionName("wrsCommitImageElement");
            fileInfoTable.setFileActivationOverridePredicate(saveFileActivationOverride);
            fileInfoTable.setSelectablePredicate(AllFilesPredicate.getInstance());
        } else {
            fileInfoTable.setSelectablePredicate(OnlyFoldersPredicate.getInstance());
        }
        
        imageChooser.setInitialized(true);   
    }
    
%>
